/*
 *  TOPPERS/A-OSBENCH
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Operating System Benchmark
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: perf_histogram.h 783 2014-05-29 00:56:33Z honda $
 */

/*
 *		¹Իʬ۽ץ⥸塼historam.h ǽɾС
 */

/*
 *  ꥸʥƧإåե
 */
#ifndef PERF_HISTOGRAM_H
#define PERF_HISTOGRAM_H

#include "perf_timer.h"


#ifndef HIST_GET_TIM                /* ¹Իַ¬Ѥθ߻μ */
#ifndef TOPPERS_SUPPORT_GET_UTM
#error get_utm is not supported
#endif /* TOPPERS_SUPPORT_GET_UTM */
#define HIST_GET_TIM(p_time)	((void) perf_get_100ntime(p_time))
#endif /* HIST_GET_TIM */

#ifndef HIST_CONV_TIM               /* κ¹Ի֤ؤѴ */
#define HIST_CONV_TIM(time)		((uint32) (time - overhead_time))
#endif /* HIST_CONV_TIM */

#ifndef HIST_BM_HOOK                /* ¹Իַ¬ľ˹Ԥ٤ */
#define HIST_BM_HOOK()
#endif /* HIST_BM_HOOK */


/*
 *  ¹Իʬ۷¬ο
 */
#ifndef TNUM_HIST
#define TNUM_HIST		10
#endif /* TNUM_HIST */

/*
 *  åȰ¸ѹ뤿Υޥ
 */
#ifndef HISTTIM                     /* ¹Իַ¬ѤλΥǡ */
#define HISTTIM			uint32
#endif /* HISTTIM */

/*
 *  ¹Իʬ۷¬IDκǾͤȺ
 */
#define TMIN_HISTID		1
#define TMAX_HISTID		((TMIN_HISTID + TNUM_HIST) - 1)


/* ¬ͻ()κǾ͡ͼ */
#define RET_MIN_VALUE	0
#define RET_MAX_VALUE	1


/*
 *  ¹Իʬ۷¬֥å
 */
typedef struct histogram_control_block {
	HISTTIM	begin_time;             /* ¬ϻ */
	uint32	maxval;                 /* ʬۤϿ */
	uint16	*histarea;              /* ʬۤϿΰ */
	uint16	over;                   /* ֤Ķٿ */
	uint16	under;                  /* ֤εžٿ */
	boolean	initialized;            /* ѤߤɤΥե饰 */
} HISTCB;


extern volatile uint32 overhead_time;
extern HISTCB histcb_table[TNUM_HIST];


#endif /* PERF_HISTOGRAM_H */
