/*
 *  TOPPERS/A-OSBENCH
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Operating System Benchmark
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: test_common_lib.c 783 2014-05-29 00:56:33Z honda $
 */

/*
 *  ƥȥ饤֥(¸)
 */


#include "test_common_lib.h"


#ifndef TotalNumberOfCores
/* 󥰥륳ξ */
static volatile uint32  check_count;
#else
/* ޥξ */
static volatile uint32  check_count_mc[TotalNumberOfCores];
static volatile uint32  local_phase[TotalNumberOfCores];
static volatile uint32  global_phase;

#define TEST_BUSY_LOOP   1000
#define TEST_LOOP_COUNT  100000
#endif  /* TotalNumberOfCores */

/*
 *  åݥ̲ξ(TRUE:FALSE:۾)
 */
volatile uint8	cp_state;


/*
 * åݥȥ󥿽
 */
void
test_init_check_cnt(void)
{
#ifndef TotalNumberOfCores
	check_count = 0U;
#else
	/* ޥ */
	uint16 i;

	for (i = 0; i < TotalNumberOfCores; i++) {
		check_count_mc[i] = 0U;
	}
#endif
}


#ifdef TotalNumberOfCores
/*
 *  Ʊեν
 */
void
test_init_sync_cnt(void)
{
	uint16 i;

	for (i = 0; i < TotalNumberOfCores; i++) {
		local_phase[i] = 0U;
	}
	global_phase = 0U;
}
#endif


/*
 *  ƥȥ饤֥
 */
void
test_init_test_lib(void)
{
#ifndef TotalNumberOfCores
	check_count = 0U;
#else
	/* ޥ */
	uint16 i;

	for (i = 0; i < TotalNumberOfCores; i++) {
		check_count_mc[i] = 0U;
		local_phase[i] = 0U;
	}
	global_phase = 0U;
#endif /* TotalNumberOfCores */

	cp_state = TRUE;

	test_init_impl_lib();
}


#ifdef TotalNumberOfCores
void
test_init_test_lib_eachcore(void)
{
	test_init_impl_lib_eachcore();
}
#endif /* TotalNumberOfCores */


#ifndef TotalNumberOfCores
/*
 *  åݥ(󥰥륳)
 */
void
test_check_point(uint32 count)
{
	uint8	errorflag = FALSE;
	boolean	locked;

	/*
	 *  ߶ػ߾֤Ǥʤ硤
	 *  SuspendAllInterruptsˤ߶ػ߾֤ˤ
	 */
	locked = test_dis_int();

	/*  󥹥å */
	check_count++;
	if (check_count == count) {
		test_outputlog_1("Check point %d passed.", count);
	}
	else {
		test_outputlog_1("## Unexpected check point %d.", count);
		errorflag = TRUE;
	}

	/* ߶ػ߾֤ */
	test_ena_int(locked);

	if (errorflag == TRUE) {
		cp_state = FALSE;
		test_shutdown();
	}
}


/*
 *  λåݥ(󥰥륳)
 */
void
test_check_finish(uint32 count)
{
	test_check_point(count);
	if (cp_state == TRUE) {
		test_outputlog_0("All check points passed.");
	}
	test_shutdown();
}

#else /* TotalNumberOfCores */
/*
 *  åݥ(ޥ)
 */
void
test_mc_check_point(uint8 id, uint32 count)
{
	uint8		errorflag = FALSE;
	boolean		locked;
	uint8		coreid;

	/*
	 *  ߶ػ߾֤Ǥʤ硤
	 *  SuspendAllInterruptsˤ߶ػ߾֤ˤ
	 */
	locked = test_dis_int();

	/* ID */
	coreid = GetCoreID();

	/*
	 * ǻꤷIDȰۤʤ
	 */
	if (coreid != id) {
		test_outputlog_2("## Core %d : Wrong CoreID is specified [%d]", coreid, id);
		test_outputlog_2("## in \"test_mc_check_point(%d, %d)\".", id, count);
		errorflag = TRUE;
	}
	else {
		/*
		 *  󥹥å
		 */
		check_count_mc[coreid]++;
		if (check_count_mc[coreid] == count) {
			test_outputlog_2("Core %d : Check point %d passed.", coreid, count);
		}
		else {
			test_outputlog_2("## Core %d : Unexpected Check Point : %d", coreid, count);
			test_outputlog_2("## in \"test_mc_check_point(%d, %d)\".", id, count);
			errorflag = TRUE;
		}
	}

	/* ߶ػ߾֤ */
	test_ena_int(locked);

	if (errorflag == TRUE) {
		cp_state = FALSE;
		test_shutdown();
	}
}


/*
 *  λåݥ(ޥ)
 */
void
test_mc_check_finish(uint8 id, uint32 count)
{
	test_mc_check_point(id, count);
	if (cp_state == TRUE) {
		test_outputlog_1("Core %d : All check points passed.", id);
	}
	test_shutdown();
}


/*
 *  ХꥢƱ(ޥ)
 */
void
test_barrier_sync(uint32 phase, uint16 core_num)
{
	volatile uint32  i;
	volatile uint32  flag;
	CoreIdType coreid;
	uint32   timeout = 0U;

	/* ID */
	coreid = GetCoreID();
	local_phase[coreid] = phase;

	/* ޥξ */
	if(coreid == OS_CORE_ID_MASTER) {
		do {
			flag = 0;
			for(i = 0; i < TotalNumberOfCores; i++) {
				if(local_phase[i] == phase) {
					flag++;
				}
			}
			test_busywait();
			timeout++;
			if(timeout > TEST_LOOP_COUNT) {
				goto timeout_exit;
			}
		} while(flag < core_num);
		global_phase = phase;
	}
	/* 졼֥ξ */
	else {
		while(global_phase != phase) {
			test_busywait();
			timeout++;
			if(timeout > TEST_LOOP_COUNT) {
				goto timeout_exit;
			}
		}
	}

	return;

  /* ƱԤǥॢȤ */
  timeout_exit:
	test_outputlog_2("## Core %d : test_barrier_sync(phase:%d) caused a timeout", coreid, phase);
	test_outputlog_2("## in \"test_barrier_sync(%d, %d)\".", phase, core_num);
	cp_state = FALSE;
	test_shutdown();
}



/*
 *  ӥȴؿ
 */
void
test_busywait(void)
{
	volatile uint32 i;

	for (i = 0U; i < TEST_BUSY_LOOP; i++) {
	}
}

#endif  /* TotalNumberOfCores */


/*
 * ߶ػ߾
 */
boolean
test_dis_int(void)
{
	boolean locked = FALSE;

	/*
	 * DisableAllInterrputˤ߶ػߤǤʤС
	 * ͥȲǽSuspendAllInterruptsǳ߶ػߤȤ
	 */
	if (test_get_disallint_state() == FALSE) {
		SuspendAllInterrupts();
		locked = TRUE;
	}
	return(locked);
}


/*
 * ߶ػ߾ֲ
 */
void
test_ena_int(boolean locked)
{
	if (locked) {
		ResumeAllInterrupts();
	}
}


/*
 *  åȥ(SCʬ)
 */
void
test_shutdown(void)
{
#ifndef TotalNumberOfCores
	ShutdownOS(E_OK);
#else
	ShutdownAllCores(E_OK);
#endif /* TotalNumberOfCores */
}

