/*
 *  TOPPERS/A-OSBENCH
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Operating System Benchmark
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: test_common_lib.h 783 2014-05-29 00:56:33Z honda $
 */

#ifndef TEST_COMMON_LIB_H
#define TEST_COMMON_LIB_H

#include "Os.h"


/* åݥȽ */
extern void test_init_check_cnt(void);

/* ƥȥ饤֥ */
extern void test_init_test_lib(void);

/* ߶ػ */
extern boolean test_dis_int(void);

/* ߶ػ߲ */
extern void test_ena_int(boolean locked);

/* ƥνλ */
extern void test_shutdown(void);

/* ӥ */
extern void test_busywait(void);

/* ¹Իʬ۷¬ν */
extern boolean init_hist(uint8 histid, uint32 maxval, uint16 *histarea);

/* ¹Իַ¬γ */
extern boolean begin_measure(uint8 histid);

/* ¹Իַ¬νλ */
extern boolean end_measure(uint8 histid);

/* ¹Իʬ۷¬ɽ */
extern boolean print_hist(uint8 histid);

/* ¬̻() */
extern uint32 calc_hist_value(uint8 histid, uint8 ret_type);

/* ƥȥ饤֥˼¸ǹԤʤ٤ */
extern void test_init_impl_lib(void);

/* ߶ػ߾֤μ */
extern boolean test_get_disallint_state(void);

/*  */
extern void test_outputlog_0(const char8* Format);
extern void test_outputlog_1(const char8* Format, sintptr Arg1);
extern void test_outputlog_2(const char8* Format, sintptr Arg1, sintptr Arg2);
extern void test_outputlog_3(const char8* Format, sintptr Arg1, sintptr Arg2, sintptr Arg3);

/* ޤεư */
extern void perf_timer_initialize(void);

/* ޤ߽ */
extern void perf_timer_terminate(void);

/* ޤεư */
extern void int_timer_initialize(uint32 type);

/* ޤ߽ */
extern void int_timer_terminate(uint32 type);

/* ߽ */
extern void test_int_raise(uint32 intno);

/* ׵Υꥢ */
extern void test_clear_int_req(uint32 intno);

/* ƥȥ饤֥ */
extern void test_init_target_lib(void);

/* ƥǼ¹Ԥƥȥ饤֥ */
extern void test_init_target_lib_eachcore(void);

/* target_cache_purge */
extern void invalidate_icache(void);

/* CPU㳰ȯ */
extern void raise_cpu_exception(void);

#ifndef TotalNumberOfCores
/* åݥȤ̲ǧ */
extern void test_check_point(uint32 count);
#else
/* Ʊեν */
void test_init_sync_cnt(void);

/* ƥȥ饤֥˳CoreǹԤʤ٤ */
extern void test_init_test_lib_eachcore(void);

/* åݥȤ̲ǧMCǡ*/
extern void test_mc_check_point(uint8 id, uint32 count);

/* ХꥢƱ */
extern void test_barrier_sync(uint32 phase, uint16 core_num);

/* ƥȥ饤֥˼¸ǹԤʤ٤MCǡ*/
extern void test_init_impl_lib_eachcore(void);

/* IDLE֤Ǥ뤫ȽǤؿ */
extern boolean test_is_core_idle(uint8 core_id);
#endif  /* TotalNumberOfCores */

#endif /* TEST_COMMON_LIB_H */
