/*
 *  TOPPERS/A-OSBENCH
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Operating System Benchmark
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: test_implement_lib.c 783 2014-05-29 00:56:33Z honda $
 */

/*
 *  ƥȥ饤֥(¸)
 */

#include "test_common_lib.h"
#include "test_target_lib.h"

#include "t_syslog.h"
#include "sysmod/serial.h"
#include "kernel/task.h"
#include "Os_Lcfg.h"


/*
 *  ƥȥ饤֥(¸)
 */
void test_init_impl_lib(void)
{
#ifndef TotalNumberOfCores
	/* 󥰥륳ξ硤Ǽ¹ */
	InitSerial();
#endif /* TotalNumberOfCores */
	test_init_target_lib();
}


#ifdef TotalNumberOfCores
#ifdef SLAVE_IDLE_TASK
volatile boolean IdleTaskFlag[TotalNumberOfCores];
#endif /* SLAVE_IDLE_TASK */


/*
 *  ƥǼ¹Ԥƥȥ饤֥
 */
void
test_init_impl_lib_eachcore(void)
{
	InitSerial();
	test_init_target_lib_eachcore();
}


/*
 *  ꤷCOREɥ֤ݤ
 */
boolean
test_is_core_idle(uint8 core_id)
{
#ifndef SLAVE_IDLE_TASK
	CCB *p_ccb;

	p_ccb  = get_p_ccb(core_id);

	return (p_ccb->p_runtsk == NULL) ? TRUE : FALSE;
#else  /* SLAVE_IDLE_TASK */
/*
 *  ॢȤĤɥ֥ե饰ǧؿ
 *  
 *  1 ɥ륿ˤʤԤ֤ΤѲǽ
 *        ؿƤӽФݤ˥ե饰񤭤뤿ᡤ
 *        ꤬٤񤭹֤ǤʤлȤʤ
 *
 *  2 : ܴؿϥСإåɡ˰
 *        ܴؿޤǽɾƤϤʤ
 *
 *		:  ɥ륿   TRUE
 *               ॢ     FALSE
 */
	boolean retval = FALSE;
	volatile uint32 i,j;

	for( i=0; i < 1000; i++ ){
		/* 
		 * ꥳǽɾؤαƶ㸺뤿 
		 * ꥢ٤򲼤(롼)
		 */
		for( j = 0 ; j < 9 ; j++ )
		{
			;
		}
		if(IdleTaskFlag[core_id]){
			IdleTaskFlag[core_id] = FALSE;
			retval = TRUE;
			break;
		}
	}
	return retval;
#endif /* SLAVE_IDLE_TASK */
}
#endif /* TotalNumberOfCores */


/*
 *  ߶ػ߾ּAPI
 */
boolean
test_get_disallint_state(void)
{
	boolean	state = FALSE;
#ifdef TotalNumberOfCores
	CCB		*p_ccb = get_my_p_ccb();
	uint16	callevel_stat = p_ccb->callevel_stat;
#endif /* TotalNumberOfCores */

	if (((callevel_stat & TSYS_DISALLINT) != 0U) ||
		((callevel_stat & TSYS_SUSALLINT) != 0U)) {
		state = TRUE;
	}

	return(state);
}


/*
 *  (񼰻0)
 */
void
test_outputlog_0(const char8* Format)
{
	syslog_0(LOG_NOTICE, Format);
}


/*
 *  (񼰻1)
 */
void
test_outputlog_1(const char8* Format, sintptr Arg1)
{
	syslog_1(LOG_NOTICE, Format, Arg1);
}


/*
 *  (񼰻2)
 */
void
test_outputlog_2(const char8* Format, sintptr Arg1, sintptr Arg2)
{
	syslog_2(LOG_NOTICE, Format, Arg1, Arg2);
}


/*
 *  (񼰻3)
 */
void
test_outputlog_3(const char8* Format, sintptr Arg1, sintptr Arg2, sintptr Arg3)
{
	syslog_3(LOG_NOTICE, Format, Arg1, Arg2, Arg3);
}

