/*
 *  TOPPERS/A-OSBENCH
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Operating System Benchmark
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: perf_timer.c 783 2014-05-29 00:56:33Z honda $
 */

/*
 *  ɾѥޡɥ饤
 */

#include "perf_timer.h"


/* ********************** ե꡼󥿥ޡ ********************** */

/*
 *  ޤεư
 */
void
perf_timer_initialize(void)
{
	/* ȥå */
	sil_wrw_iop((void *) (PERF_TIMER_BASE + PERF_TIMER_CONTROL), PERF_TIMER_CONTROL_STOP);

	/* ꥻå */
	sil_wrw_iop((void *) (PERF_TIMER_BASE + PERF_TIMER_STATUS), 0x00U);
	sil_wrw_iop((void *) (PERF_TIMER_BASE + PERF_TIMER_PERIODL), (TIM_CYC & 0xffffU));       /* 󥿡å 16bit */
	sil_wrw_iop((void *) (PERF_TIMER_BASE + PERF_TIMER_PERIODH), ((uint32) TIM_CYC >> 16));  /* 󥿡å 16bit */

	/*  */
	sil_wrw_iop((void *) (PERF_TIMER_BASE + PERF_TIMER_CONTROL), PERF_TIMER_CONTROL_START | PERF_TIMER_CONTROL_CONT);
}


/*
 *  ޤ߽
 */
void
perf_timer_terminate(void)
{
	/* ȥå */
	sil_wrw_iop((void *) (PERF_TIMER_BASE + PERF_TIMER_CONTROL), PERF_TIMER_CONTROL_STOP);

	/* ׵Υꥢ */
	sil_wrw_iop((void *) (PERF_TIMER_BASE + PERF_TIMER_STATUS), 0x00U);
}


/* ********************** ޡʳѡ ********************** */

/*
 *  ߥޡΥ١ɥ쥹ơ֥
 */
const uint32
int_timer_base_table[] = {
  INT_A_TIMER_BASE,
  INT_B_TIMER_BASE,
#ifdef TotalNumberOfCores
  INT_C_TIMER_BASE,
#endif  /* TotalNumberOfCores */
};


/*
 *  ޤεư
 */
void
int_timer_initialize(uint32 tim_type)
{
	volatile uint32 int_timer_base;
  
	/* ޡΥ١ɥ쥹 */
	int_timer_base = int_timer_base_table[tim_type];

	/* ȥå */
	sil_wrw_iop((void *) (int_timer_base + INT_TIMER_CONTROL), INT_TIMER_CONTROL_STOP);

	/* ꥻå */
	sil_wrw_iop((void *) (int_timer_base + INT_TIMER_STATUS), 0x00U);
	sil_wrw_iop((void *) (int_timer_base + INT_TIMER_PERIODL), (INT_TIM_CYC & 0xffffU));       /* 󥿡å 16bit */
	sil_wrw_iop((void *) (int_timer_base + INT_TIMER_PERIODH), ((uint32) INT_TIM_CYC >> 16));  /* 󥿡å 16bit */

	/*  */
	sil_wrw_iop((void *) (int_timer_base + INT_TIMER_CONTROL), INT_TIMER_CONTROL_START | INT_TIMER_CONTROL_CONT | INT_TIMER_CONTROL_ITO);
}


/*
 *  ޤ߽
 */
void
int_timer_terminate(uint32 tim_type)
{
	volatile uint32 int_timer_base;

	/* ޡΥ١ɥ쥹 */
	int_timer_base = int_timer_base_table[tim_type];

	/* ȥå */
	sil_wrw_iop((void *) (int_timer_base + INT_TIMER_CONTROL), INT_TIMER_CONTROL_STOP);

	/* ׵Υꥢ */
	sil_wrw_iop((void *) (int_timer_base + INT_TIMER_STATUS), 0x00U);
}


