/*
 *  TOPPERS/A-OSBENCH
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Operating System Benchmark
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: perf_timer.h 783 2014-05-29 00:56:33Z honda $
 */

/*
 *  ǽɾѥޡɥ饤
 */
#ifndef PERF_TIMER_H
#define PERF_TIMER_H

#include "test_implement_lib.h"


/* ********************** ե꡼󥿥ޡ ********************** */
/*
 *  ե꡼󥿥ޡΥ١ɥ쥹
 */
/* 󥰥륳ξ */
#ifndef TotalNumberOfCores
#define PERF_TIMER_BASE  0x080003e0 /* ޥ١ɥ쥹 */

/* ޥξ */
#else
#define PERF_TIMER_BASE  0x0c0003e0 /* ޥ١ɥ쥹 */
#endif  /* TotalNumberOfCores */

/*
 *  쥸
 */
#define PERF_TIMER_STATUS   0x00
#define PERF_TIMER_CONTROL  0x04
#define PERF_TIMER_PERIODL  0x08
#define PERF_TIMER_PERIODH  0x0C
#define PERF_TIMER_SNAPL    0x10
#define PERF_TIMER_SNAPH    0x14

/*
 *  ӥå
 */
#define PERF_TIMER_STATUS_RUN  0x02
#define PERF_TIMER_STATUS_TO   0x01

#define PERF_TIMER_CONTROL_STOP   0x08
#define PERF_TIMER_CONTROL_START  0x04
#define PERF_TIMER_CONTROL_CONT   0x02
#define PERF_TIMER_CONTROL_ITO    0x01

/*
 *  ޥåñ̤[MHz]
 */
#define PERF_TIMER_CLOCK  60

/*
 *	ޥ()
 */
#define TIM_CYC  ((uint32) 0xfffffffeU)


/*
 *  ޤθͤɽФ
 */
LOCAL_INLINE uint32
perf_timer_get_current(void)
{
    uint32 count;

	/* ʥåץ쥸˽񤭹ͤۡɤ */
	sil_wrw_iop((void *) (PERF_TIMER_BASE + PERF_TIMER_SNAPL), 0x00U);

	/* ͤɤ߹ */
	count = sil_rew_iop((void *) (PERF_TIMER_BASE + PERF_TIMER_SNAPL));
	count |= sil_rew_iop((void *) (PERF_TIMER_BASE + PERF_TIMER_SNAPH)) << 16;

    return(TIM_CYC - count);
}

/*
 * 
 */
LOCAL_INLINE
void
perf_get_100ntime(uint32 *p_time)
{
	*p_time = perf_timer_get_current() * 10 / PERF_TIMER_CLOCK;
}


/* ********************** ޡʳѡ ********************** */
/*
 *  ޡΥ١ɥ쥹
 */
/* 󥰥륳ξ */
#ifndef TotalNumberOfCores
#define INT_A_TIMER_BASE  0x080003c0
#define INT_B_TIMER_BASE  0x080003a0

/* ޥξ */
#else   /* TotalNumberOfCores */
#define INT_A_TIMER_BASE  0x0c0003c0
#define INT_B_TIMER_BASE  0x0c0003a0
#define INT_C_TIMER_BASE  0x0c0003e0
#endif  /* TotalNumberOfCores */

/*
 *  쥸
 */
#define INT_TIMER_STATUS   0x00
#define INT_TIMER_CONTROL  0x04
#define INT_TIMER_PERIODL  0x08
#define INT_TIMER_PERIODH  0x0C
#define INT_TIMER_SNAPL    0x10
#define INT_TIMER_SNAPH    0x14

/*
 *  ӥå
 */
#define INT_TIMER_STATUS_RUN  0x02
#define INT_TIMER_STATUS_TO   0x01

#define INT_TIMER_CONTROL_STOP   0x08
#define INT_TIMER_CONTROL_START  0x04
#define INT_TIMER_CONTROL_CONT   0x02
#define INT_TIMER_CONTROL_ITO    0x01

/* ޥåñ̤[MHz] */
#define INT_TIMER_CLOCK  60

/*
 *	ޥ(1[ms])
 */
#define INT_TIM_CYC  ((uint32) (60000U))

/*
 * ޡμɽη
 */

#define INT_A_TIMER   0
#define INT_B_TIMER   1
#ifdef TotalNumberOfCores
#define INT_C_TIMER   2
#endif  /* TotalNumberOfCores */

/* ١ɥ쥹ơ֥ */
extern const uint32 int_timer_base_table[];

/*
 *  ޤθͤɽФ
 */
LOCAL_INLINE uint32
int_timer_get_current(uint32 tim_type)
{
    uint32 count;
	volatile uint32 int_timer_base;

	/* ޡΥ١ɥ쥹 */
	int_timer_base = int_timer_base_table[tim_type];

	/* ʥåץ쥸˽񤭹ͤۡɤ */
	sil_wrw_iop((void *) (int_timer_base + INT_TIMER_SNAPL), 0x00U);

	/* ͤɤ߹ */
	count = sil_rew_iop((void *) (int_timer_base + INT_TIMER_SNAPL));
	count |= sil_rew_iop((void *) (int_timer_base + INT_TIMER_SNAPH)) << 16;

    return(INT_TIM_CYC - count);
}

/*
 * 
 */
LOCAL_INLINE void
int_get_100ntime(uint32 *p_time, uint32 tim_type)
{
	*p_time = int_timer_get_current(tim_type) * 10 / INT_TIMER_CLOCK;
}


#endif /* PERF_TIMER_H */
