/*
 *  TOPPERS/A-OSBENCH
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Operating System Benchmark
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: test_target_lib.c 783 2014-05-29 00:56:33Z honda $
 */

/*
 *  ƥȥ饤֥(¸)
 */

#include "test_target_lib.h"
#include "target_hw_counter.h"


/* ʳγ̵ֹ뤹ޥ(ޥ) */
#ifdef TotalNumberOfCores
#define TEST_IGNORE_INTERRUPT(intno)			\
	if ((GetCoreID() + 1) != (intno >> 16U)) {	\
		return;									\
	}
#endif /* TotalNumberOfCores */


/*
 *  ƥȥ饤֥(åȰ¸)
 */
void
test_init_target_lib(void)
{
}

/*
 *  ƥǼ¹Ԥƥȥ饤֥(åȰ¸)
 */
void
test_init_target_lib_eachcore(void)
{
}


/*
 *  ߽
 */
void
test_int_raise(uint32 intno)
{
#ifdef TotalNumberOfCores
	TEST_IGNORE_INTERRUPT(intno);
#endif /* TotalNumberOfCores */

	/*  */
	sil_wrw_iop((void *) TIMER_CONTROL(intno), TIMER_CONTROL_STOP);

	/* ޤγ׵Υꥢ */
	sil_wrw_iop((void *) TIMER_STATUS(intno), 0x00);

	/* ޥ󥿤0x01򥻥åȤ뤳Ȥǡλ */
	sil_wrw_iop((void *) TIMER_PERIODH(intno), 0x00);
	sil_wrw_iop((void *) TIMER_PERIODL(intno), 0x01);

	/* ޳ */
	sil_wrw_iop((void *) TIMER_CONTROL(intno), TIMER_CONTROL_ITO | TIMER_CONTROL_START);
}

/*
 *  ׵Υꥢ
 */
void
test_clear_int_req(uint32 intno)
{
#ifdef TotalNumberOfCores
	TEST_IGNORE_INTERRUPT(intno);
#endif /* TotalNumberOfCores */

	/* ޤγ׵Υꥢ */
	sil_wrw_iop((void *) TIMER_STATUS(intno), 0x00);
}


/*
 *  CPU㳰ȯ
 */
void
raise_cpu_exception(void)
{
	Asm("div zero, zero, zero");
}
