/*
 *  TOPPERS/A-OSBENCH
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Operating System Benchmark
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: test_target_lib.h 783 2014-05-29 00:56:33Z honda $
 */

#ifndef TEST_TARGET_LIB_H
#define TEST_TARGET_LIB_H

#include "test_implement_lib.h"
#include "test_trap_include.h"


/* ֹ(perf_sc3) */
#ifndef USE_MC_KERNEL
#define INTNO_ACTISR2_1    18
#define INTNO_ACTISR2_2    19
#define INTNO_RESOURCE     21
#define INTNO_SET_EVENT_1  22
#define INTNO_SET_EVENT_2  23
#define INTNO_TERAPP_F1    24
#define INTNO_TERAPP_F2    25
#define INTNO_TERAPP_F3    26
#define INTNO_TERAPP_F4    27
#define INTNO_PROHOOK_A    28
#define INTNO_INT_A_TIMER  30
#define INTNO_INT_B_TIMER  29
#else /* USE_MC_KERNEL */
#define INTNO_ACTISR2_1    0x10012
#define INTNO_ACTISR2_2    0x10013
#define INTNO_RESOURCE     0x10015
#define INTNO_SET_EVENT_1  0x10016
#define INTNO_SET_EVENT_2  0x10017
#define INTNO_TERAPP_F1    0x10018
#define INTNO_TERAPP_F2    0x10019
#define INTNO_TERAPP_F3    0x1001a
#define INTNO_TERAPP_F4    0x1001b
#define INTNO_PROHOOK_A    0x1001c
#define INTNO_INT_A_TIMER  0x1001e
#define INTNO_INT_B_TIMER  0x1001d
#define INTNO_INT_MC_TIMER 0x1001f
#endif /* USE_MC_KERNEL */

/* ͥ */
#define INTPRI_TIMER_NUM   4


/* ɥ륿 */
#if defined(TotalNumberOfCores) && defined(SLAVE_IDLE_TASK)
#define IDLE_LOOP_NUM 9
extern volatile boolean IdleTaskFlag[TotalNumberOfCores];

LOCAL_INLINE void
idle_task_process(uint8 core_num)
{
	volatile uint32 i;
	while(1){
		IdleTaskFlag[core_num] = TRUE;
		for(i = 0; i < IDLE_LOOP_NUM; i++){
			;
		}
	}
}
#endif /* TotalNumberOfCores && SLAVE_IDLE_TASK */


/* trapб */
#ifdef USE_SCALABILITYCLASS3
#ifndef TotalNumberOfCores
#define TFN_INVALIDATE_ICACHE	 64
#define TFN_TEST_CHECK_POINT	 65
#else   /* TotalNumberOfCores */
#define TFN_INVALIDATE_ICACHE	 75
#define TFN_TEST_MC_CHECK_POINT	 76
#define TFN_TEST_BARRIER_SYNC	 77
#endif	/* TotalNumberOfCores */


#ifndef TotalNumberOfCores
LOCAL_INLINE void
_trap_test_check_point(uint32 count)
{
	CAL_SVC_1N(void, TFN_TEST_CHECK_POINT, uint32, count);
}
#else   /* TotalNumberOfCores */
LOCAL_INLINE void
_trap_test_mc_check_point(uint8 id, uint32 count)
{
	CAL_SVC_2N(void, TFN_TEST_MC_CHECK_POINT, uint8, id, uint32, count);
}

LOCAL_INLINE void
_trap_test_barrier_sync(uint32 phase, uint16 core_num)
{
	CAL_SVC_2N(void, TFN_TEST_BARRIER_SYNC, uint32, phase, uint16, core_num);
}
#endif	/* TotalNumberOfCores */

LOCAL_INLINE void
_trap_invalidate_icache(void)
{
	CAL_SVC_0N(void, TFN_INVALIDATE_ICACHE);
}
#endif /* USE_SCALABILITYCLASS3 */


#endif  /* TEST_TARGET_LIB_H */
