/*
 *  TOPPERS/A-OSBENCH
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Operating System Benchmark
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: perf_star_shut.c 783 2014-05-29 00:56:33Z honda $
 */


#include "perf_star_shut.h"


/*
 *  ¹ԻʬۤϿΰ: 65535ޤǷ¬ǽȤ
 */
uint16 histarea[2][MAX_TIME + 1];
uint16 histarea100us[MAX_TIME_100US + 1];


/* overhead value */
volatile uint32 overhead_time = 0;


/*
 * ᥤؿ
 */
sint32
main(void)
{
	static uint32  cnt_main = 0;
	uint32 i;

	/* 2ܰʹ */
	if (cnt_main != FIRST_COUNT) {
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);
#ifdef VALIDATE_SEQUENCE
		if (cnt_main < LOOP_COUNT) {
			SEQUENCE_CHECK_START();
			SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		}
#endif  /* VALIDATE_SEQUENCE */
	}
	/* ư */
	else {
		test_init_test_lib();
		perf_timer_initialize();

		test_init_check_cnt();

		/* *** measure overhead *** */
		test_outputlog_0("== measure overhead ==");
		init_hist(1, MAX_TIME_100US, histarea100us);
		for (i = 0; i < LOOP_COUNT; i++) {
			begin_measure(1);
			end_measure(1);
		}
		print_hist(1);

		/* *** OverHead Time *** */
		overhead_time = calc_hist_value(1, RET_MIN_VALUE);
		test_outputlog_1("== overhead_time:%d[100nsec] ==",overhead_time);

		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		init_hist(1, MAX_TIME, histarea[0]);   /* StartOS()    */
	}

	/* ¹Բ󥯥 */
	cnt_main++;

    /* StartOS()LOOP_COUNTԤʤ */
	if (cnt_main <= LOOP_COUNT) {
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
		begin_measure(1);
		StartOS(MainApp);
	}

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	test_outputlog_0("== START_SHUTDOWN ==");
	test_outputlog_0("= Star-1 =");
	print_hist(1);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);
	test_outputlog_0("All evaluation items were measured.");

	while (1) {}
}   /* main */


/*
 * *************************************
 * *********** ᥤ󥿥 ************
 * *************************************
 */
TASK(MainTask)
{
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);

	ShutdownOS(E_OK);
}

TASK(StartShut_Task1)
{
	TerminateTask();
}

#if defined(PERF_OBJECT_4) || defined(PERF_OBJECT_8) || defined(PERF_OBJECT_16)
TASK(StartShut_Task2)
{
	TerminateTask();
}

TASK(StartShut_Task3)
{
	TerminateTask();
}

TASK(StartShut_Task4)
{
	TerminateTask();
}

#if defined(PERF_OBJECT_8) || defined(PERF_OBJECT_16)
TASK(StartShut_Task5)
{
	TerminateTask();
}

TASK(StartShut_Task6)
{
	TerminateTask();
}

TASK(StartShut_Task7)
{
	TerminateTask();
}

TASK(StartShut_Task8)
{
	TerminateTask();
}

#ifdef PERF_OBJECT_16
TASK(StartShut_Task9)
{
	TerminateTask();
}

TASK(StartShut_Task10)
{
	TerminateTask();
}

TASK(StartShut_Task11)
{
	TerminateTask();
}

TASK(StartShut_Task12)
{
	TerminateTask();
}

TASK(StartShut_Task13)
{
	TerminateTask();
}

TASK(StartShut_Task14)
{
	TerminateTask();
}

TASK(StartShut_Task15)
{
	TerminateTask();
}

TASK(StartShut_Task16)
{
	TerminateTask();
}
#endif /* PERF_OBJECT_16 */
#endif /* PERF_OBJECT_8 || PERF_OBJECT_16 */
#endif /* PERF_OBJECT_4 || PERF_OBJECT_8 || PERF_OBJECT_16 */


/*
 *  顼եå롼
 */
void ErrorHook(StatusType Error)
{
	test_outputlog_0("Error was occured!!");
}
