/*
 *  TOPPERS/A-OSBENCH
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Operating System Benchmark
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: perf_general.c 783 2014-05-29 00:56:33Z honda $
 */


#include "perf_general.h"


/* Ƚѥե饰 */
volatile boolean check_isr_act = FALSE;


/*
 * *************************************
 * ********* ƽñ̤ **********
 * *************************************
 */
/* *** TrustedFunction *** */
/* ؿ(Tfn_TFN_1) */
StatusType TRUSTED_tfn_tfn1(TrustedFunctionIndexType FunctionIndex,TrustedFunctionParameterRefType FunctionParams)
{
	return(E_OK);
}

/* ؿ(Tfn_TFN_2) */
StatusType TRUSTED_tfn_tfn2(TrustedFunctionIndexType FunctionIndex,TrustedFunctionParameterRefType FunctionParams)
{
	end_measure(2);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	return(E_OK);
}


/* *** TerApp_D *** */
/* T_OSAP1 */
TASK(T_OSAP1_TerApp_D_Task3)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP1_TerApp_D_Task1);

	/* TerApp-4 */
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);
	begin_measure(1);
	TerminateApplication(NT_OSAP1_TERAPP_D, RESTART);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();
}

/* T_OSAP2 */
TASK(T_OSAP2_TerApp_D_Task3)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP2_TerApp_D_Task1);
	ActivateTask(NT_OSAP2_TerApp_D_Task4);
	ActivateTask(NT_OSAP2_TerApp_D_Task5);
	ActivateTask(NT_OSAP2_TerApp_D_Task6);

	/* TerApp-4 */
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);
	begin_measure(1);
	TerminateApplication(NT_OSAP2_TERAPP_D, RESTART);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();
}

/* T_OSAP3 */
TASK(T_OSAP3_TerApp_D_Task3)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP3_TerApp_D_Task1);
	ActivateTask(NT_OSAP3_TerApp_D_Task4);
	ActivateTask(NT_OSAP3_TerApp_D_Task5);
	ActivateTask(NT_OSAP3_TerApp_D_Task6);
	ActivateTask(NT_OSAP3_TerApp_D_Task7);
	ActivateTask(NT_OSAP3_TerApp_D_Task8);
	ActivateTask(NT_OSAP3_TerApp_D_Task9);
	ActivateTask(NT_OSAP3_TerApp_D_Task10);

	/* TerApp-4 */
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);
	begin_measure(1);
	TerminateApplication(NT_OSAP3_TERAPP_D, RESTART);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();
}

/* T_OSAP4 */
TASK(T_OSAP4_TerApp_D_Task3)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP4_TerApp_D_Task1);
	ActivateTask(NT_OSAP4_TerApp_D_Task4);
	ActivateTask(NT_OSAP4_TerApp_D_Task5);
	ActivateTask(NT_OSAP4_TerApp_D_Task6);
	ActivateTask(NT_OSAP4_TerApp_D_Task7);
	ActivateTask(NT_OSAP4_TerApp_D_Task8);
	ActivateTask(NT_OSAP4_TerApp_D_Task9);
	ActivateTask(NT_OSAP4_TerApp_D_Task10);
	ActivateTask(NT_OSAP4_TerApp_D_Task11);
	ActivateTask(NT_OSAP4_TerApp_D_Task12);
	ActivateTask(NT_OSAP4_TerApp_D_Task13);
	ActivateTask(NT_OSAP4_TerApp_D_Task14);
	ActivateTask(NT_OSAP4_TerApp_D_Task15);
	ActivateTask(NT_OSAP4_TerApp_D_Task16);
	ActivateTask(NT_OSAP4_TerApp_D_Task17);
	ActivateTask(NT_OSAP4_TerApp_D_Task18);

	/* TerApp-4 */
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);
	begin_measure(1);
	TerminateApplication(NT_OSAP4_TERAPP_D, RESTART);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();
}


/* *** TerApp_E *** */
/* T_OSAP1 */
TASK(T_OSAP1_TerApp_E_Task2)
{
	/* ResetTask */
	ActivateTask(NT_OSAP1_TerApp_E_ResetTask);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP1_TerApp_E_Task1);

	/* TerApp-5(begin_measure) */
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);
	begin_measure(1);
	TerminateApplication(NT_OSAP1_TERAPP_E, RESTART);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	TerminateTask();
}

/* T_OSAP2 */
TASK(T_OSAP2_TerApp_E_Task2)
{
	/* ResetTask */
	ActivateTask(NT_OSAP2_TerApp_E_ResetTask);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP2_TerApp_E_Task1);
	ActivateTask(NT_OSAP2_TerApp_E_Task4);
	ActivateTask(NT_OSAP2_TerApp_E_Task5);
	ActivateTask(NT_OSAP2_TerApp_E_Task6);

	/* TerApp-5(begin_measure) */
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);
	begin_measure(1);
	TerminateApplication(NT_OSAP2_TERAPP_E, RESTART);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	TerminateTask();
}

/* T_OSAP3 */
TASK(T_OSAP3_TerApp_E_Task2)
{
	/* ResetTask */
	ActivateTask(NT_OSAP3_TerApp_E_ResetTask);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP3_TerApp_E_Task1);
	ActivateTask(NT_OSAP3_TerApp_E_Task4);
	ActivateTask(NT_OSAP3_TerApp_E_Task5);
	ActivateTask(NT_OSAP3_TerApp_E_Task6);
	ActivateTask(NT_OSAP3_TerApp_E_Task7);
	ActivateTask(NT_OSAP3_TerApp_E_Task8);
	ActivateTask(NT_OSAP3_TerApp_E_Task9);
	ActivateTask(NT_OSAP3_TerApp_E_Task10);

	/* TerApp-5(begin_measure) */
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);
	begin_measure(1);
	TerminateApplication(NT_OSAP3_TERAPP_E, RESTART);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	TerminateTask();
}

/* T_OSAP4 */
TASK(T_OSAP4_TerApp_E_Task2)
{
	/* ResetTask */
	ActivateTask(NT_OSAP4_TerApp_E_ResetTask);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP4_TerApp_E_Task1);
	ActivateTask(NT_OSAP4_TerApp_E_Task4);
	ActivateTask(NT_OSAP4_TerApp_E_Task5);
	ActivateTask(NT_OSAP4_TerApp_E_Task6);
	ActivateTask(NT_OSAP4_TerApp_E_Task7);
	ActivateTask(NT_OSAP4_TerApp_E_Task8);
	ActivateTask(NT_OSAP4_TerApp_E_Task9);
	ActivateTask(NT_OSAP4_TerApp_E_Task10);
	ActivateTask(NT_OSAP4_TerApp_E_Task11);
	ActivateTask(NT_OSAP4_TerApp_E_Task12);
	ActivateTask(NT_OSAP4_TerApp_E_Task13);
	ActivateTask(NT_OSAP4_TerApp_E_Task14);
	ActivateTask(NT_OSAP4_TerApp_E_Task15);
	ActivateTask(NT_OSAP4_TerApp_E_Task16);
	ActivateTask(NT_OSAP4_TerApp_E_Task17);
	ActivateTask(NT_OSAP4_TerApp_E_Task18);

	/* TerApp-5(begin_measure) */
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);
	begin_measure(1);
	TerminateApplication(NT_OSAP4_TERAPP_E, RESTART);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	TerminateTask();
}


/* *** TerApp_F *** */
/* T_OSAP1 */
ISR(T_OSAP1_TerApp_F_Isr2)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);

	/*  Ƚѥե饰ꥢ */
	check_isr_act = TRUE;
	test_clear_int_req(INTNO_TERAPP_F1);

	/* TerApp-6(begin_measure) */
	begin_measure(1);
	TerminateApplication(NT_OSAP1_TERAPP_F, RESTART);
}

StatusType TRUSTED_terapp_isr2_tfn1(TrustedFunctionIndexType FunctionIndex,TrustedFunctionParameterRefType FunctionParams)
{
	test_int_raise(INTNO_TERAPP_F1);
	return(E_OK);
}

/* T_OSAP2 */
ISR(T_OSAP2_TerApp_F_Isr2)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);

	/*  Ƚѥե饰ꥢ */
	check_isr_act = TRUE;
	test_clear_int_req(INTNO_TERAPP_F2);

	ActivateTask(NT_OSAP2_TerApp_F_Task3);
	ActivateTask(NT_OSAP2_TerApp_F_Task4);
	ActivateTask(NT_OSAP2_TerApp_F_Task5);

	/* TerApp-6(begin_measure) */
	begin_measure(1);
	TerminateApplication(NT_OSAP2_TERAPP_F, RESTART);
}

StatusType TRUSTED_terapp_isr2_tfn2(TrustedFunctionIndexType FunctionIndex,TrustedFunctionParameterRefType FunctionParams)
{
	test_int_raise(INTNO_TERAPP_F2);
	return(E_OK);
}

/* T_OSAP3 */
ISR(T_OSAP3_TerApp_F_Isr2)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);

	/*  Ƚѥե饰ꥢ */
	check_isr_act = TRUE;
	test_clear_int_req(INTNO_TERAPP_F3);

	ActivateTask(NT_OSAP3_TerApp_F_Task3);
	ActivateTask(NT_OSAP3_TerApp_F_Task4);
	ActivateTask(NT_OSAP3_TerApp_F_Task5);
	ActivateTask(NT_OSAP3_TerApp_F_Task6);
	ActivateTask(NT_OSAP3_TerApp_F_Task7);
	ActivateTask(NT_OSAP3_TerApp_F_Task8);
	ActivateTask(NT_OSAP3_TerApp_F_Task9);

	/* TerApp-6(begin_measure) */
	begin_measure(1);
	TerminateApplication(NT_OSAP3_TERAPP_F, RESTART);
}

StatusType TRUSTED_terapp_isr2_tfn3(TrustedFunctionIndexType FunctionIndex,TrustedFunctionParameterRefType FunctionParams)
{
	test_int_raise(INTNO_TERAPP_F3);
	return(E_OK);
}

/* T_OSAP4 */
ISR(T_OSAP4_TerApp_F_Isr2)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);

	/*  Ƚѥե饰ꥢ */
	check_isr_act = TRUE;
	test_clear_int_req(INTNO_TERAPP_F4);

	ActivateTask(NT_OSAP4_TerApp_F_Task3);
	ActivateTask(NT_OSAP4_TerApp_F_Task4);
	ActivateTask(NT_OSAP4_TerApp_F_Task5);
	ActivateTask(NT_OSAP4_TerApp_F_Task6);
	ActivateTask(NT_OSAP4_TerApp_F_Task7);
	ActivateTask(NT_OSAP4_TerApp_F_Task8);
	ActivateTask(NT_OSAP4_TerApp_F_Task9);
	ActivateTask(NT_OSAP4_TerApp_F_Task10);
	ActivateTask(NT_OSAP4_TerApp_F_Task11);
	ActivateTask(NT_OSAP4_TerApp_F_Task12);
	ActivateTask(NT_OSAP4_TerApp_F_Task13);
	ActivateTask(NT_OSAP4_TerApp_F_Task14);
	ActivateTask(NT_OSAP4_TerApp_F_Task15);
	ActivateTask(NT_OSAP4_TerApp_F_Task16);
	ActivateTask(NT_OSAP4_TerApp_F_Task17);

	/* TerApp-6(begin_measure) */
	begin_measure(1);
	TerminateApplication(NT_OSAP4_TERAPP_F, RESTART);
}

StatusType TRUSTED_terapp_isr2_tfn4(TrustedFunctionIndexType FunctionIndex,TrustedFunctionParameterRefType FunctionParams)
{
	test_int_raise(INTNO_TERAPP_F4);
	return(E_OK);
}


/* *** CheckTaskMemory *** */
StatusType TRUSTED_ChkMem_tfn1(TrustedFunctionIndexType FunctionIndex,TrustedFunctionParameterRefType FunctionParams)
{
	struct func_param *local_param = FunctionParams;

	/* ChkMem-1 */
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);
	begin_measure(1);
	CheckTaskMemoryAccess(NT_OSAP1_ChkMem_Task1, local_param->data_addr, local_param->data_size);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	return(E_OK);
}


#ifdef USE_MC_KERNEL
/* *** TerApp[MC] *** */
/* T_OSAP1_M */
TASK(T_OSAP1_M_TerApp_MC_Task1)
{
	TaskStateType	TerApp_task2_state;
	TaskStateType	TerApp_Retask3_state;
	ApplicationStateType TerApp_nosap_state;

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP1_S_TerApp_MC_Task2);

	do {
		GetTaskState(NT_OSAP1_S_TerApp_MC_Task2, &TerApp_task2_state);
		GetTaskState(NT_OSAP1_S_TerApp_MC_ReTask3, &TerApp_Retask3_state);
	} while ((TerApp_task2_state != RUNNING) && (TerApp_Retask3_state != SUSPENDED));

	/* TerApp-7 */
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);
	begin_measure(1);
	TerminateApplication(NT_OSAP1_S_TERAPP_MC, RESTART);

	do {
		GetApplicationState(NT_OSAP1_S_TERAPP_MC, &TerApp_nosap_state);
	} while (TerApp_nosap_state != APPLICATION_ACCESSIBLE);

	do {
		GetTaskState(NT_OSAP1_S_TerApp_MC_Task2, &TerApp_task2_state);
		GetTaskState(NT_OSAP1_S_TerApp_MC_ReTask3, &TerApp_Retask3_state);
	} while ((TerApp_task2_state != SUSPENDED) && (TerApp_Retask3_state != SUSPENDED));

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);
	ActivateTask(NT_OSAP1_S_TerApp_MC_Task2);

	do {
		GetTaskState(NT_OSAP1_S_TerApp_MC_Task2, &TerApp_task2_state);
	} while (TerApp_task2_state != RUNNING);

	/* TerApp-8 */
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);
	begin_measure(2);
	TerminateApplication(NT_OSAP1_S_TERAPP_MC, RESTART);
	end_measure(2);

	do {
		GetApplicationState(NT_OSAP1_S_TERAPP_MC, &TerApp_nosap_state);
	} while (TerApp_nosap_state != APPLICATION_ACCESSIBLE);

	do {
		GetTaskState(NT_OSAP1_S_TerApp_MC_Task2, &TerApp_task2_state);
		GetTaskState(NT_OSAP1_S_TerApp_MC_ReTask3, &TerApp_Retask3_state);
	} while ((TerApp_task2_state != SUSPENDED) && (TerApp_Retask3_state != SUSPENDED));

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);
	TerminateTask();
}

/* T_OSAP2_M */
TASK(T_OSAP2_M_TerApp_MC_Task1)
{
	TaskStateType	TerApp_task2_state;
	TaskStateType	TerApp_Retask3_state;
	TaskStateType	TerApp_task6_state;
	ApplicationStateType TerApp_nosap_state;

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP2_S_TerApp_MC_Task2);

	do {
		GetTaskState(NT_OSAP2_S_TerApp_MC_Task6, &TerApp_task6_state);
	} while (TerApp_task6_state != READY);

	/* TerApp-7 */
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);
	begin_measure(1);
	TerminateApplication(NT_OSAP2_S_TERAPP_MC, RESTART);

	do {
		GetApplicationState(NT_OSAP2_S_TERAPP_MC, &TerApp_nosap_state);
	} while (TerApp_nosap_state != APPLICATION_ACCESSIBLE);

	do {
		GetTaskState(NT_OSAP2_S_TerApp_MC_Task2, &TerApp_task2_state);
		GetTaskState(NT_OSAP2_S_TerApp_MC_ReTask3, &TerApp_Retask3_state);
	} while ((TerApp_task2_state != SUSPENDED) && (TerApp_Retask3_state != SUSPENDED));

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);
	ActivateTask(NT_OSAP2_S_TerApp_MC_Task2);

	do {
		GetTaskState(NT_OSAP2_S_TerApp_MC_Task6, &TerApp_task6_state);
	} while (TerApp_task6_state != READY);

	/* TerApp-8 */
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);
	begin_measure(2);
	TerminateApplication(NT_OSAP2_S_TERAPP_MC, RESTART);
	end_measure(2);

	do {
		GetApplicationState(NT_OSAP2_S_TERAPP_MC, &TerApp_nosap_state);
	} while (TerApp_nosap_state != APPLICATION_ACCESSIBLE);

	do {
		GetTaskState(NT_OSAP2_S_TerApp_MC_Task2, &TerApp_task2_state);
		GetTaskState(NT_OSAP2_S_TerApp_MC_ReTask3, &TerApp_Retask3_state);
	} while ((TerApp_task2_state != SUSPENDED) && (TerApp_Retask3_state != SUSPENDED));

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);
	TerminateTask();
}

/* T_OSAP3_M */
TASK(T_OSAP3_M_TerApp_MC_Task1)
{
	TaskStateType	TerApp_task2_state;
	TaskStateType	TerApp_Retask3_state;
	TaskStateType	TerApp_task10_state;
	ApplicationStateType TerApp_nosap_state;

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP3_S_TerApp_MC_Task2);

	do {
		GetTaskState(NT_OSAP3_S_TerApp_MC_Task10, &TerApp_task10_state);
	} while (TerApp_task10_state != READY);

	/* TerApp-7 */
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);
	begin_measure(1);
	TerminateApplication(NT_OSAP3_S_TERAPP_MC, RESTART);

	do {
		GetApplicationState(NT_OSAP3_S_TERAPP_MC, &TerApp_nosap_state);
	} while (TerApp_nosap_state != APPLICATION_ACCESSIBLE);

	do {
		GetTaskState(NT_OSAP3_S_TerApp_MC_Task2, &TerApp_task2_state);
		GetTaskState(NT_OSAP3_S_TerApp_MC_ReTask3, &TerApp_Retask3_state);
	} while ((TerApp_task2_state != SUSPENDED) && (TerApp_Retask3_state != SUSPENDED));

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);
	ActivateTask(NT_OSAP3_S_TerApp_MC_Task2);

	do {
		GetTaskState(NT_OSAP3_S_TerApp_MC_Task10, &TerApp_task10_state);
	} while (TerApp_task10_state != READY);

	/* TerApp-8 */
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);
	begin_measure(2);
	TerminateApplication(NT_OSAP3_S_TERAPP_MC, RESTART);
	end_measure(2);

	do {
		GetApplicationState(NT_OSAP3_S_TERAPP_MC, &TerApp_nosap_state);
	} while (TerApp_nosap_state != APPLICATION_ACCESSIBLE);

	do {
		GetTaskState(NT_OSAP3_S_TerApp_MC_Task2, &TerApp_task2_state);
		GetTaskState(NT_OSAP3_S_TerApp_MC_ReTask3, &TerApp_Retask3_state);
	} while ((TerApp_task2_state != SUSPENDED) && (TerApp_Retask3_state != SUSPENDED));

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);
	TerminateTask();
}

/* T_OSAP4_M */
TASK(T_OSAP4_M_TerApp_MC_Task1)
{
	TaskStateType	TerApp_task2_state;
	TaskStateType	TerApp_Retask3_state;
	TaskStateType	TerApp_task18_state;
	ApplicationStateType TerApp_nosap_state;

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP4_S_TerApp_MC_Task2);

	do {
		GetTaskState(NT_OSAP4_S_TerApp_MC_Task18, &TerApp_task18_state);
	} while (TerApp_task18_state != READY);

	/* TerApp-7 */
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);
	begin_measure(1);
	TerminateApplication(NT_OSAP4_S_TERAPP_MC, RESTART);

	do {
		GetApplicationState(NT_OSAP4_S_TERAPP_MC, &TerApp_nosap_state);
	} while (TerApp_nosap_state != APPLICATION_ACCESSIBLE);

	do {
		GetTaskState(NT_OSAP4_S_TerApp_MC_Task2, &TerApp_task2_state);
		GetTaskState(NT_OSAP4_S_TerApp_MC_ReTask3, &TerApp_Retask3_state);
	} while ((TerApp_task2_state != SUSPENDED) && (TerApp_Retask3_state != SUSPENDED));

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);
	ActivateTask(NT_OSAP4_S_TerApp_MC_Task2);

	do {
		GetTaskState(NT_OSAP4_S_TerApp_MC_Task18, &TerApp_task18_state);
	} while (TerApp_task18_state != READY);

	/* TerApp-8 */
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);
	begin_measure(2);
	TerminateApplication(NT_OSAP4_S_TERAPP_MC, RESTART);
	end_measure(2);

	do {
		GetApplicationState(NT_OSAP4_S_TERAPP_MC, &TerApp_nosap_state);
	} while (TerApp_nosap_state != APPLICATION_ACCESSIBLE);

	do {
		GetTaskState(NT_OSAP4_S_TerApp_MC_Task2, &TerApp_task2_state);
		GetTaskState(NT_OSAP4_S_TerApp_MC_ReTask3, &TerApp_Retask3_state);
	} while ((TerApp_task2_state != SUSPENDED) && (TerApp_Retask3_state != SUSPENDED));

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);
	TerminateTask();
}


#ifdef SLAVE_IDLE_TASK
/* IdleTask(SlaveCore) */
TASK(S_IdleTask)
{
	idle_task_process(OS_CORE_ID_SLAVE);
	TerminateTask();
}
#endif /* SLAVE_IDLE_TASK */
#endif /* USE_MC_KERNEL */
