/*
 *  TOPPERS/A-OSBENCH
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Operating System Benchmark
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: perf_general.h 783 2014-05-29 00:56:33Z honda $
 */

#ifndef PERF_GENERAL_H
#define PERF_GENERAL_H

#include "Os.h"
#include "perf_histogram.h"
#include "test_common_lib.h"
#include "test_target_lib.h"


#define TASK_STACK_SIZE 512
#define ISR_STACK_SIZE 256


/* ¬ñ̻ */
#define MAX_TIME        2500U
#define MAX_TIME_100US  2000U

/* 10s, 100us test */
#ifdef USE_MC_KERNEL
#define NO_LOOP1 510
#else  /* USE_MC_KERNEL */
#define NO_LOOP1 525
#endif /* USE_MC_KERNEL */


/* ؿѥ᡼(CheckTaskMemory) */
struct func_param {
	uint32	data_size;
	uint32*	data_addr;
};

/* 󥹥åͭˤޥ */
/* #define VALIDATE_SEQUENCE */
#ifdef VALIDATE_SEQUENCE
#define SEQUENCE_CHECK_START() (test_init_check_cnt())
#ifndef USE_MC_KERNEL
#define SEQUENCE_CHECK(arg1, arg2) (test_check_point(arg2))
#else  /* USE_MC_KERNEL */
#define SEQUENCE_CHECK(arg1, arg2) (test_mc_check_point(arg1, arg2))
#endif /* USE_MC_KERNEL */
#else   /* VALIDATE_SEQUENCE */
#define SEQUENCE_CHECK_START()
#define SEQUENCE_CHECK(arg1, arg2)
#endif  /* VALIDATE_SEQUENCE */

/* ¬ */
#ifdef VALIDATE_SEQUENCE
#define LOOP_COUNT 2U
#else  /* VALIDATE_SEQUENCE */
#define LOOP_COUNT 10000U
#endif /* VALIDATE_SEQUENCE */

/* MC */
/* OS_CORE_ID_SLAVE  */
#if OS_CORE_ID_MASTER == OS_CORE_ID_0
#define OS_CORE_ID_SLAVE OS_CORE_ID_1
#else  /* OS_CORE_ID_MASTER  */
#define OS_CORE_ID_SLAVE OS_CORE_ID_0
#endif /* OS_CORE_ID_MASTER */

extern uint16 histarea[2][MAX_TIME + 1];
extern uint16 histarea100us[MAX_TIME_100US + 1];
extern volatile uint32 overhead_time;


#endif /* PERF_GENERAL_H */
