/*
 *  TOPPERS/A-OSBENCH
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Operating System Benchmark
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: perf_general_main_task.c 783 2014-05-29 00:56:33Z honda $
 */


#include "perf_general.h"


/*
 *  ¹ԻʬۤϿΰ
 */
uint16 histarea[2][MAX_TIME + 1];
uint16 histarea100us[MAX_TIME_100US + 1];

/* overhead value */
volatile uint32 overhead_time = 0;

/*
 * ᥤؿ
 */
sint32
main(void)
{
#ifndef USE_MC_KERNEL
	test_init_test_lib();
	StartOS(MainApp);
#else   /* USE_MC_KERNEL */
	StatusType	ercd;
	CoreIdType	i;

	if (GetCoreID() == OS_CORE_ID_MASTER) {
		test_init_test_lib();
		test_init_test_lib_eachcore();
		for (i = 0; i < TotalNumberOfCores; i++) {
			if (i != OS_CORE_ID_MASTER) {
				StartCore(i, &ercd);
			}
		}
		StartOS(MainApp);
	}
	else {
		test_init_test_lib_eachcore();
		StartOS(DONOTCARE);
	}
#endif /* USE_MC_KERNEL */

	while (1) {}
}   /* main */


/*
 *  histareaޤȤƽؿ
 */
void init_hist_group(uint8 loop)
{
	uint8 i;
	for (i = 0; i < loop; i++) {
		init_hist(i + TMIN_HISTID, MAX_TIME, histarea[i]);
	}
}


/* ¬˼»ܤؿ */
void init_perf_func(uint8 hist_loop)
{
	init_hist_group(hist_loop);

	perf_timer_initialize();

#ifdef USE_MC_KERNEL
	test_init_sync_cnt();
#endif /* USE_MC_KERNEL */
}


/*
 * *************************************
 * *********** ᥤ󥿥 ************
 * *************************************
 */
TASK(MainTask)
{
	uint32 i;
	volatile uint32 j, loop;

	perf_timer_initialize();

/* *** Act IdleTask(Slave) *** */
#if defined(USE_MC_KERNEL) && defined(SLAVE_IDLE_TASK)
	ActivateTask(S_IdleTask);
#endif /* USE_MC_KERNEL && SLAVE_IDLE_TASK */

/* *** measure overhead *** */
	test_outputlog_0("== measure overhead ==");
	init_hist(1, MAX_TIME_100US, histarea100us);
	for (i = 0; i < LOOP_COUNT; i++) {
		begin_measure(1);
		end_measure(1);
	}
	print_hist(1);


/* *** OverHead Time *** */
	overhead_time = calc_hist_value(1, RET_MIN_VALUE);
	test_outputlog_1("== overhead_time:%d[100nsec] ==",overhead_time);


/* *** 100us test *** */
	test_outputlog_0("== 100us test ==");
	init_hist(1, MAX_TIME_100US, histarea100us);
	loop = NO_LOOP1;
	for (i = 0; i < LOOP_COUNT; i++) {
		begin_measure(1);
		for (j = 0; j < loop; j++) {
		}
		end_measure(1);
	}
	print_hist(1);


#if 0
/* *** 10s test *** */
	test_outputlog_0("== 10s test start ==");
	loop = NO_LOOP1 * 100000;
	for (j = 0; j < loop; j++) {
	}
	test_outputlog_0("== 10s test end ==");

#ifndef USE_MC_KERNEL
	ShutdownOS(E_OK);
#else  /* USE_MC_KERNEL */
	ShutdownAllCores(E_OK);
#endif /* USE_MC_KERNEL */
#endif /* 0 */


/* *** TrustedFunction *** */
	test_outputlog_0("== TrustedFunction ==");
	init_perf_func(2);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(NT_OSAP1_Tfn_Task1);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);
	}
	test_outputlog_0("== Tfn-1 ==");
	print_hist(1);
	test_outputlog_0("== Tfn-2 ==");
	print_hist(2);


/* *** TerApp_C *** */
	test_outputlog_0("==  TerApp_C ==");
	/* number_of_objects:1 */
	init_perf_func(1);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(NT_OSAP1_TerApp_C_Task1);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);
	}
	test_outputlog_0("== TerApp-3(number_of_objects:1) ==");
	print_hist(1);

	/* number_of_objects:4 */
	init_perf_func(1);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(NT_OSAP2_TerApp_C_Task1);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);
	}
	test_outputlog_0("== TerApp-3(number_of_objects:4) ==");
	print_hist(1);

	/* number_of_objects:8 */
	init_perf_func(1);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(NT_OSAP3_TerApp_C_Task1);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);
	}
	test_outputlog_0("== TerApp-3(number_of_objects:8) ==");
	print_hist(1);

	/* number_of_objects:16 */
	init_perf_func(1);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(NT_OSAP4_TerApp_C_Task1);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);
	}
	test_outputlog_0("== TerApp-3(number_of_objects:16) ==");
	print_hist(1);


/* *** TerApp_D *** */
	test_outputlog_0("== TerApp_D ==");
	/* number_of_objects:1 */
	init_perf_func(1);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(T_OSAP1_TerApp_D_Task3);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);
	}
	test_outputlog_0("== TerApp-4(number_of_objects:1) ==");
	print_hist(1);

	/* number_of_objects:4 */
	init_perf_func(1);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(T_OSAP2_TerApp_D_Task3);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);
	}
	test_outputlog_0("== TerApp-4(number_of_objects:4) ==");
	print_hist(1);

	/* number_of_objects:8 */
	init_perf_func(1);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(T_OSAP3_TerApp_D_Task3);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);
	}
	test_outputlog_0("== TerApp-4(number_of_objects:8) ==");
	print_hist(1);

	/* number_of_objects:16 */
	init_perf_func(1);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(T_OSAP4_TerApp_D_Task3);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);
	}
	test_outputlog_0("== TerApp-4(number_of_objects:16) ==");
	print_hist(1);


/* *** TerApp_E *** */
	test_outputlog_0("== TerApp_E ==");
	/* number_of_objects:1 */
	init_perf_func(1);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(T_OSAP1_TerApp_E_Task2);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);
	}
	test_outputlog_0("== TerApp-5(number_of_objects:1) ==");
	print_hist(1);

	/* number_of_objects:4 */
	init_perf_func(1);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(T_OSAP2_TerApp_E_Task2);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);
	}
	test_outputlog_0("== TerApp-5(number_of_objects:4) ==");
	print_hist(1);

	/* number_of_objects:8 */
	init_perf_func(1);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(T_OSAP3_TerApp_E_Task2);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);
	}
	test_outputlog_0("== TerApp-5(number_of_objects:8) ==");
	print_hist(1);

	/* number_of_objects:16 */
	init_perf_func(1);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(T_OSAP4_TerApp_E_Task2);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);
	}
	test_outputlog_0("== TerApp-5(number_of_objects:16) ==");
	print_hist(1);


/* *** TerApp_F *** */
	test_outputlog_0("== TerApp_F ==");
	/* number_of_objects:1 */
	init_perf_func(1);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(NT_OSAP1_TerApp_F_Task1);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);
	}
	test_outputlog_0("== TerApp-6(number_of_objects:1) ==");
	print_hist(1);

	/* number_of_objects:4 */
	init_perf_func(1);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(NT_OSAP2_TerApp_F_Task1);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);
	}
	test_outputlog_0("== TerApp-6(number_of_objects:4) ==");
	print_hist(1);

	/* number_of_objects:8 */
	init_perf_func(1);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(NT_OSAP3_TerApp_F_Task1);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);
	}
	test_outputlog_0("== TerApp-6(number_of_objects:8) ==");
	print_hist(1);

	/* number_of_objects:16 */
	init_perf_func(1);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(NT_OSAP4_TerApp_F_Task1);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);
	}
	test_outputlog_0("== TerApp-6(number_of_objects:16) ==");
	print_hist(1);


#ifdef USE_MC_KERNEL
/* *** TerApp[MC] *** */
	test_outputlog_0("== TerApp[MC] ==");
	/* number_of_objects:1 */
	init_perf_func(2);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(T_OSAP1_M_TerApp_MC_Task1);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 7);
	}
	test_outputlog_0("== TerApp-7(number_of_objects:1) ==");
	print_hist(1);
	test_outputlog_0("== TerApp-8(number_of_objects:1) ==");
	print_hist(2);

	/* number_of_objects:4 */
	init_perf_func(2);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(T_OSAP2_M_TerApp_MC_Task1);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 7);
	}
	test_outputlog_0("== TerApp-7(number_of_objects:4) ==");
	print_hist(1);
	test_outputlog_0("== TerApp-8(number_of_objects:4) ==");
	print_hist(2);

	/* number_of_objects:8 */
	init_perf_func(2);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(T_OSAP3_M_TerApp_MC_Task1);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 7);
	}
	test_outputlog_0("== TerApp-7(number_of_objects:8) ==");
	print_hist(1);
	test_outputlog_0("== TerApp-8(number_of_objects:8) ==");
	print_hist(2);

	/* number_of_objects:16 */
	init_perf_func(2);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(T_OSAP4_M_TerApp_MC_Task1);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 7);
	}
	test_outputlog_0("== TerApp-7(number_of_objects:16) ==");
	print_hist(1);
	test_outputlog_0("== TerApp-8(number_of_objects:16) ==");
	print_hist(2);
#endif /* USE_MC_KERNEL */


/* *** CheckTaskMemory *** */
	test_outputlog_0("== CheckTaskMemory ==");
	init_perf_func(1);

	for (i = 0; i < LOOP_COUNT; i++) {
		SEQUENCE_CHECK_START();
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
		ActivateTask(NT_OSAP1_ChkMem_Task1);
		SEQUENCE_CHECK(OS_CORE_ID_MASTER, 6);	
	}
	test_outputlog_0("== ChkMem-1 ==");
	print_hist(1);

	test_outputlog_0("All evaluation items were measured.");

#ifndef USE_MC_KERNEL
	ShutdownOS(E_OK);
#else  /* USE_MC_KERNEL */
	ShutdownAllCores(E_OK);
#endif /* USE_MC_KERNEL */
}


/*
 *  ץƥեå롼
 */
ProtectionReturnType
ProtectionHook(StatusType FatalError)
{
	test_outputlog_0("ProtectionHook was occured!!");

	return(PRO_SHUTDOWN);
}


/*
 *  顼եå롼
 */
void ErrorHook(StatusType Error)
{
}
