/*
 *  TOPPERS/A-OSBENCH
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Operating System Benchmark
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: perf_general_nt.c 783 2014-05-29 00:56:33Z honda $
 */

#include "perf_general.h"
#include "perf_general_nt.h"


/* Ƚ̥ե饰 */
#ifdef USE_MC_KERNEL
volatile boolean terapp_second_act = FALSE;
#endif /* USE_MC_KERNEL */

/*
 * *************************************
 * ********* ƽñ̤ **********
 * *************************************
 */
/* *** TrustedFunction *** */
/* NT_OSAP1 */
TASK(NT_OSAP1_Tfn_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);

	/* Tfn-1 */
	begin_measure(1);
	CallTrustedFunction(TFN_TFN_1, NULL_PTR);
	end_measure(1);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);

	/* Tfn-2 */
	begin_measure(2);
	CallTrustedFunction(TFN_TFN_2, NULL_PTR);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);
	TerminateTask();
}


/* *** TerApp_C *** */
/* NT_OSAP1 */
TASK(NT_OSAP1_TerApp_C_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);

	ActivateTask(NT_OSAP1_TerApp_C_Task3);

	TerminateTask();

}

TASK(NT_OSAP1_TerApp_C_ReTask2)
{
	end_measure(1);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	/* OSAPƵư */
	AllowAccess();

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	TerminateTask();
}

TASK(NT_OSAP1_TerApp_C_Task3)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);

	/* TerApp-3 */
	begin_measure(1);
	TerminateApplication(NT_OSAP1_TERAPP_C, RESTART);

	TerminateTask();
}

/* NT_OSAP2 */
TASK(NT_OSAP2_TerApp_C_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);

	ActivateTask(NT_OSAP2_TerApp_C_Task3);

	TerminateTask();

}

TASK(NT_OSAP2_TerApp_C_ReTask2)
{
	end_measure(1);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	/* OSAPƵư */
	AllowAccess();

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);
	TerminateTask();
}

TASK(NT_OSAP2_TerApp_C_Task3)
{
	ActivateTask(NT_OSAP2_TerApp_C_Task4);
	ActivateTask(NT_OSAP2_TerApp_C_Task5);
	ActivateTask(NT_OSAP2_TerApp_C_Task6);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);

	/* TerApp-3 */
	begin_measure(1);
	TerminateApplication(NT_OSAP2_TERAPP_C, RESTART);

	TerminateTask();
}

TASK(NT_OSAP2_TerApp_C_Task4)
{
	TerminateTask();
}

TASK(NT_OSAP2_TerApp_C_Task5)
{
	TerminateTask();
}

TASK(NT_OSAP2_TerApp_C_Task6)
{
	TerminateTask();
}

/* NT_OSAP3 */
TASK(NT_OSAP3_TerApp_C_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);

	ActivateTask(NT_OSAP3_TerApp_C_Task3);

	TerminateTask();

}

TASK(NT_OSAP3_TerApp_C_ReTask2)
{
	end_measure(1);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	/* OSAPƵư */
	AllowAccess();

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_C_Task3)
{
	ActivateTask(NT_OSAP3_TerApp_C_Task4);
	ActivateTask(NT_OSAP3_TerApp_C_Task5);
	ActivateTask(NT_OSAP3_TerApp_C_Task6);
	ActivateTask(NT_OSAP3_TerApp_C_Task7);
	ActivateTask(NT_OSAP3_TerApp_C_Task8);
	ActivateTask(NT_OSAP3_TerApp_C_Task9);
	ActivateTask(NT_OSAP3_TerApp_C_Task10);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);

	/* TerApp-3 */
	begin_measure(1);
	TerminateApplication(NT_OSAP3_TERAPP_C, RESTART);

	TerminateTask();
}

TASK(NT_OSAP3_TerApp_C_Task4)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_C_Task5)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_C_Task6)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_C_Task7)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_C_Task8)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_C_Task9)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_C_Task10)
{
	TerminateTask();
}

/* NT_OSAP4 */
TASK(NT_OSAP4_TerApp_C_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);

	ActivateTask(NT_OSAP4_TerApp_C_Task3);

	TerminateTask();

}

TASK(NT_OSAP4_TerApp_C_ReTask2)
{
	end_measure(1);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	/* OSAPƵư */
	AllowAccess();

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_C_Task3)
{
	ActivateTask(NT_OSAP4_TerApp_C_Task4);
	ActivateTask(NT_OSAP4_TerApp_C_Task5);
	ActivateTask(NT_OSAP4_TerApp_C_Task6);
	ActivateTask(NT_OSAP4_TerApp_C_Task7);
	ActivateTask(NT_OSAP4_TerApp_C_Task8);
	ActivateTask(NT_OSAP4_TerApp_C_Task9);
	ActivateTask(NT_OSAP4_TerApp_C_Task10);
	ActivateTask(NT_OSAP4_TerApp_C_Task11);
	ActivateTask(NT_OSAP4_TerApp_C_Task12);
	ActivateTask(NT_OSAP4_TerApp_C_Task13);
	ActivateTask(NT_OSAP4_TerApp_C_Task14);
	ActivateTask(NT_OSAP4_TerApp_C_Task15);
	ActivateTask(NT_OSAP4_TerApp_C_Task16);
	ActivateTask(NT_OSAP4_TerApp_C_Task17);
	ActivateTask(NT_OSAP4_TerApp_C_Task18);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 3);

	/* TerApp-3 */
	begin_measure(1);
	TerminateApplication(NT_OSAP4_TERAPP_C, RESTART);

	TerminateTask();
}

TASK(NT_OSAP4_TerApp_C_Task4)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_C_Task5)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_C_Task6)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_C_Task7)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_C_Task8)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_C_Task9)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_C_Task10)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_C_Task11)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_C_Task12)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_C_Task13)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_C_Task14)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_C_Task15)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_C_Task16)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_C_Task17)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_C_Task18)
{
	TerminateTask();
}


/* *** TerApp_D *** */
/* NT_OSAP1 */
TASK(NT_OSAP1_TerApp_D_Task1)
{
	TerminateTask();
}

TASK(NT_OSAP1_TerApp_D_ReTask2)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	/* OSAPƵư */
	AllowAccess();

	TerminateTask();
}

/* NT_OSAP2 */
TASK(NT_OSAP2_TerApp_D_Task1)
{
	TerminateTask();
}

TASK(NT_OSAP2_TerApp_D_ReTask2)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	/* OSAPƵư */
	AllowAccess();

	TerminateTask();
}

TASK(NT_OSAP2_TerApp_D_Task4)
{
	TerminateTask();
}

TASK(NT_OSAP2_TerApp_D_Task5)
{
	TerminateTask();
}

TASK(NT_OSAP2_TerApp_D_Task6)
{
	TerminateTask();
}

/* NT_OSAP3 */
TASK(NT_OSAP3_TerApp_D_Task1)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_D_ReTask2)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	/* OSAPƵư */
	AllowAccess();

	TerminateTask();
}

TASK(NT_OSAP3_TerApp_D_Task4)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_D_Task5)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_D_Task6)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_D_Task7)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_D_Task8)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_D_Task9)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_D_Task10)
{
	TerminateTask();
}

/* NT_OSAP4 */
TASK(NT_OSAP4_TerApp_D_Task1)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_D_ReTask2)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	/* OSAPƵư */
	AllowAccess();

	TerminateTask();
}

TASK(NT_OSAP4_TerApp_D_Task4)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_D_Task5)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_D_Task6)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_D_Task7)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_D_Task8)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_D_Task9)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_D_Task10)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_D_Task11)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_D_Task12)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_D_Task13)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_D_Task14)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_D_Task15)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_D_Task16)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_D_Task17)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_D_Task18)
{
	TerminateTask();
}


/* *** TerApp_E *** */
/* NT_OSAP1 */
TASK(NT_OSAP1_TerApp_E_ResetTask)
{
	TerminateTask();
}

TASK(NT_OSAP1_TerApp_E_Task1)
{
	TerminateTask();
}

TASK(NT_OSAP1_TerApp_E_ReTask3)
{
	/* TerApp-5(end_measure) */
	end_measure(1);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	/* OSAPƵư */
	AllowAccess();

	TerminateTask();
}

/* NT_OSAP2 */
TASK(NT_OSAP2_TerApp_E_ResetTask)
{
	TerminateTask();
}

TASK(NT_OSAP2_TerApp_E_Task1)
{
	TerminateTask();
}

TASK(NT_OSAP2_TerApp_E_ReTask3)
{
	/* TerApp-5(end_measure) */
	end_measure(1);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	/* OSAPƵư */
	AllowAccess();

	TerminateTask();
}

TASK(NT_OSAP2_TerApp_E_Task4)
{
	TerminateTask();
}

TASK(NT_OSAP2_TerApp_E_Task5)
{
	TerminateTask();
}

TASK(NT_OSAP2_TerApp_E_Task6)
{
	TerminateTask();
}

/* NT_OSAP3 */
TASK(NT_OSAP3_TerApp_E_ResetTask)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_E_Task1)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_E_ReTask3)
{
	/* TerApp-5(end_measure) */
	end_measure(1);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	/* OSAPƵư */
	AllowAccess();

	TerminateTask();
}

TASK(NT_OSAP3_TerApp_E_Task4)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_E_Task5)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_E_Task6)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_E_Task7)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_E_Task8)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_E_Task9)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_E_Task10)
{
	TerminateTask();
}

/* NT_OSAP4 */
TASK(NT_OSAP4_TerApp_E_ResetTask)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_E_Task1)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_E_ReTask3)
{
	/* TerApp-5(end_measure) */
	end_measure(1);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	/* OSAPƵư */
	AllowAccess();

	TerminateTask();
}

TASK(NT_OSAP4_TerApp_E_Task4)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_E_Task5)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_E_Task6)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_E_Task7)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_E_Task8)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_E_Task9)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_E_Task10)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_E_Task11)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_E_Task12)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_E_Task13)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_E_Task14)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_E_Task15)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_E_Task16)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_E_Task17)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_E_Task18)
{
	TerminateTask();
}


/* *** TerApp_F *** */
/* NT_OSAP1 */
TASK(NT_OSAP1_TerApp_F_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);

	/* trigger Isr2 */
	check_isr_act = FALSE;
	CallTrustedFunction(TRIGGER_TERAPP_ISR2_TFN1, NULL_PTR);
	while (check_isr_act == FALSE);

	TerminateTask();
}

TASK(NT_OSAP1_TerApp_F_ReTask2)
{
	/* TerApp-6(end_measure) */
	end_measure(1);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	/* OSAPƵư */
	AllowAccess();

	TerminateTask();
}

/* NT_OSAP2 */
TASK(NT_OSAP2_TerApp_F_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);

	/* trigger Isr2 */
	check_isr_act = FALSE;
	CallTrustedFunction(TRIGGER_TERAPP_ISR2_TFN2, NULL_PTR);
	while (check_isr_act == FALSE);

	TerminateTask();
}

TASK(NT_OSAP2_TerApp_F_ReTask2)
{
	/* TerApp-6(end_measure) */
	end_measure(1);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	/* OSAPƵư */
	AllowAccess();

	TerminateTask();
}

TASK(NT_OSAP2_TerApp_F_Task3)
{
	TerminateTask();
}

TASK(NT_OSAP2_TerApp_F_Task4)
{
	TerminateTask();
}

TASK(NT_OSAP2_TerApp_F_Task5)
{
	TerminateTask();
}

/* NT_OSAP3 */
TASK(NT_OSAP3_TerApp_F_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);

	/* trigger Isr2 */
	check_isr_act = FALSE;
	CallTrustedFunction(TRIGGER_TERAPP_ISR2_TFN3, NULL_PTR);
	while (check_isr_act == FALSE);

	TerminateTask();
}

TASK(NT_OSAP3_TerApp_F_ReTask2)
{
	/* TerApp-6(end_measure) */
	end_measure(1);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	/* OSAPƵư */
	AllowAccess();

	TerminateTask();
}

TASK(NT_OSAP3_TerApp_F_Task3)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_F_Task4)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_F_Task5)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_F_Task6)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_F_Task7)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_F_Task8)
{
	TerminateTask();
}

TASK(NT_OSAP3_TerApp_F_Task9)
{
	TerminateTask();
}

/* NT_OSAP4 */
TASK(NT_OSAP4_TerApp_F_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);

	/* trigger Isr2 */
	check_isr_act = FALSE;
	CallTrustedFunction(TRIGGER_TERAPP_ISR2_TFN4, NULL_PTR);
	while (check_isr_act == FALSE);

	TerminateTask();
}

TASK(NT_OSAP4_TerApp_F_ReTask2)
{
	/* TerApp-6(end_measure) */
	end_measure(1);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	/* OSAPƵư */
	AllowAccess();

	TerminateTask();
}

TASK(NT_OSAP4_TerApp_F_Task3)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_F_Task4)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_F_Task5)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_F_Task6)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_F_Task7)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_F_Task8)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_F_Task9)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_F_Task10)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_F_Task11)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_F_Task12)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_F_Task13)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_F_Task14)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_F_Task15)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_F_Task16)
{
	TerminateTask();
}

TASK(NT_OSAP4_TerApp_F_Task17)
{
	TerminateTask();
}


/* *** CheckTaskMemory *** */
/* NT_OSAP1 */
const uint32 check_data = 1;

TASK(NT_OSAP1_ChkMem_Task1)
{
	struct	func_param local;

	local.data_size = sizeof(check_data);
	local.data_addr = (uint32*)&check_data;

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);

	CallTrustedFunction(CHKMEM_TFN1, &local);

	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);
	TerminateTask();
}


/* MC KERNEL */
#ifdef USE_MC_KERNEL
/* *** TerApp[MC] *** */
/* NT_OSAP1_S */
TASK(NT_OSAP1_S_TerApp_MC_Task2)
{
	while (1) {
	}
	TerminateTask();
}

TASK(NT_OSAP1_S_TerApp_MC_ReTask3)
{
	if (terapp_second_act == FALSE) {
		end_measure(1);

		/* CheckPoint(1) - OS_CORE_ID_SLAVE */
		SEQUENCE_CHECK(OS_CORE_ID_SLAVE, 1);
		terapp_second_act = TRUE;
	}
	else {
		/* CheckPoint(2) - OS_CORE_ID_SLAVE */
		SEQUENCE_CHECK(OS_CORE_ID_SLAVE, 2);
		terapp_second_act = FALSE;
	}
	AllowAccess();

	TerminateTask();
}

/* NT_OSAP2_S */
TASK(NT_OSAP2_S_TerApp_MC_Task2)
{
	ActivateTask(NT_OSAP2_S_TerApp_MC_Task4);
	ActivateTask(NT_OSAP2_S_TerApp_MC_Task5);
	ActivateTask(NT_OSAP2_S_TerApp_MC_Task6);

	while (1) {
	}
	TerminateTask();
}

TASK(NT_OSAP2_S_TerApp_MC_ReTask3)
{
	if (terapp_second_act == FALSE) {
		end_measure(1);

		/* CheckPoint(1) - OS_CORE_ID_SLAVE */
		SEQUENCE_CHECK(OS_CORE_ID_SLAVE, 1);
		terapp_second_act = TRUE;
	}
	else {
		/* CheckPoint(2) - OS_CORE_ID_SLAVE */
		SEQUENCE_CHECK(OS_CORE_ID_SLAVE, 2);
		terapp_second_act = FALSE;
	}
	AllowAccess();

	TerminateTask();
}

TASK(NT_OSAP2_S_TerApp_MC_Task4)
{
	TerminateTask();
}

TASK(NT_OSAP2_S_TerApp_MC_Task5)
{
	TerminateTask();
}

TASK(NT_OSAP2_S_TerApp_MC_Task6)
{
	TerminateTask();
}

/* NT_OSAP3_S */
TASK(NT_OSAP3_S_TerApp_MC_Task2)
{
	ActivateTask(NT_OSAP3_S_TerApp_MC_Task4);
	ActivateTask(NT_OSAP3_S_TerApp_MC_Task5);
	ActivateTask(NT_OSAP3_S_TerApp_MC_Task6);
	ActivateTask(NT_OSAP3_S_TerApp_MC_Task7);
	ActivateTask(NT_OSAP3_S_TerApp_MC_Task8);
	ActivateTask(NT_OSAP3_S_TerApp_MC_Task9);
	ActivateTask(NT_OSAP3_S_TerApp_MC_Task10);

	while (1) {
	}
	TerminateTask();
}

TASK(NT_OSAP3_S_TerApp_MC_ReTask3)
{
	if (terapp_second_act == FALSE) {
		end_measure(1);

		/* CheckPoint(1) - OS_CORE_ID_SLAVE */
		SEQUENCE_CHECK(OS_CORE_ID_SLAVE, 1);
		terapp_second_act = TRUE;
	}
	else {
		/* CheckPoint(2) - OS_CORE_ID_SLAVE */
		SEQUENCE_CHECK(OS_CORE_ID_SLAVE, 2);
		terapp_second_act = FALSE;
	}
	AllowAccess();

	TerminateTask();
}

TASK(NT_OSAP3_S_TerApp_MC_Task4)
{
	TerminateTask();
}

TASK(NT_OSAP3_S_TerApp_MC_Task5)
{
	TerminateTask();
}

TASK(NT_OSAP3_S_TerApp_MC_Task6)
{
	TerminateTask();
}

TASK(NT_OSAP3_S_TerApp_MC_Task7)
{
	TerminateTask();
}

TASK(NT_OSAP3_S_TerApp_MC_Task8)
{
	TerminateTask();
}

TASK(NT_OSAP3_S_TerApp_MC_Task9)
{
	TerminateTask();
}

TASK(NT_OSAP3_S_TerApp_MC_Task10)
{
	TerminateTask();
}

/* NT_OSAP4_S */
TASK(NT_OSAP4_S_TerApp_MC_Task2)
{
	ActivateTask(NT_OSAP4_S_TerApp_MC_Task4);
	ActivateTask(NT_OSAP4_S_TerApp_MC_Task5);
	ActivateTask(NT_OSAP4_S_TerApp_MC_Task6);
	ActivateTask(NT_OSAP4_S_TerApp_MC_Task7);
	ActivateTask(NT_OSAP4_S_TerApp_MC_Task8);
	ActivateTask(NT_OSAP4_S_TerApp_MC_Task9);
	ActivateTask(NT_OSAP4_S_TerApp_MC_Task10);
	ActivateTask(NT_OSAP4_S_TerApp_MC_Task11);
	ActivateTask(NT_OSAP4_S_TerApp_MC_Task12);
	ActivateTask(NT_OSAP4_S_TerApp_MC_Task13);
	ActivateTask(NT_OSAP4_S_TerApp_MC_Task14);
	ActivateTask(NT_OSAP4_S_TerApp_MC_Task15);
	ActivateTask(NT_OSAP4_S_TerApp_MC_Task16);
	ActivateTask(NT_OSAP4_S_TerApp_MC_Task17);
	ActivateTask(NT_OSAP4_S_TerApp_MC_Task18);

	while (1) {
	}
	TerminateTask();
}

TASK(NT_OSAP4_S_TerApp_MC_ReTask3)
{
	if (terapp_second_act == FALSE) {
		end_measure(1);

		/* CheckPoint(1) - OS_CORE_ID_SLAVE */
		SEQUENCE_CHECK(OS_CORE_ID_SLAVE, 1);
		terapp_second_act = TRUE;
	}
	else {
		/* CheckPoint(2) - OS_CORE_ID_SLAVE */
		SEQUENCE_CHECK(OS_CORE_ID_SLAVE, 2);
		terapp_second_act = FALSE;
	}
	AllowAccess();

	TerminateTask();
}

TASK(NT_OSAP4_S_TerApp_MC_Task4)
{
	TerminateTask();
}

TASK(NT_OSAP4_S_TerApp_MC_Task5)
{
	TerminateTask();
}

TASK(NT_OSAP4_S_TerApp_MC_Task6)
{
	TerminateTask();
}

TASK(NT_OSAP4_S_TerApp_MC_Task7)
{
	TerminateTask();
}

TASK(NT_OSAP4_S_TerApp_MC_Task8)
{
	TerminateTask();
}

TASK(NT_OSAP4_S_TerApp_MC_Task9)
{
	TerminateTask();
}

TASK(NT_OSAP4_S_TerApp_MC_Task10)
{
	TerminateTask();
}

TASK(NT_OSAP4_S_TerApp_MC_Task11)
{
	TerminateTask();
}

TASK(NT_OSAP4_S_TerApp_MC_Task12)
{
	TerminateTask();
}

TASK(NT_OSAP4_S_TerApp_MC_Task13)
{
	TerminateTask();
}

TASK(NT_OSAP4_S_TerApp_MC_Task14)
{
	TerminateTask();
}

TASK(NT_OSAP4_S_TerApp_MC_Task15)
{
	TerminateTask();
}

TASK(NT_OSAP4_S_TerApp_MC_Task16)
{
	TerminateTask();
}

TASK(NT_OSAP4_S_TerApp_MC_Task17)
{
	TerminateTask();
}

TASK(NT_OSAP4_S_TerApp_MC_Task18)
{
	TerminateTask();
}
#endif /* USE_MC_KERNEL */
