/*
 *  TOPPERS/A-OSBENCH
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Operating System Benchmark
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: perf_prohook.h 783 2014-05-29 00:56:33Z honda $
 */

#ifndef PERF_PROFOOK_H
#define PERF_PROFOOK_H

#include "Os.h"
#include "perf_histogram.h"
#include "test_common_lib.h"
#include "test_target_lib.h"


#define TASK_STACK_SIZE 512
#define ISR_STACK_SIZE 256

/* ץƥեåƤӽФȽ(ProHook_xx) */
#define PROHOOK_A_TERMINATETASKISR 1U
#define PROHOOK_A_IGNORE           2U
#define PROHOOK_A_RESTART          3U
#define PROHOOK_B_TERMINATETASKISR 4U

/* 󥹥åͭˤޥ */
/* #define VALIDATE_SEQUENCE */
#ifdef VALIDATE_SEQUENCE
#define SEQUENCE_CHECK_START() (test_init_check_cnt())
#define SEQUENCE_CHECK(arg1, arg2) (test_check_point(arg2))
#else   /* VALIDATE_SEQUENCE */
#define SEQUENCE_CHECK_START()
#define SEQUENCE_CHECK(arg1, arg2)
#endif  /* VALIDATE_SEQUENCE */

/* ¬ */
#ifdef VALIDATE_SEQUENCE
#define LOOP_COUNT 2U
#else  /* VALIDATE_SEQUENCE */
#define LOOP_COUNT 10000U
#endif /* VALIDATE_SEQUENCE */

/* MC */
/* OS_CORE_ID_SLAVE  */
#if OS_CORE_ID_MASTER == OS_CORE_ID_0
#define OS_CORE_ID_SLAVE OS_CORE_ID_1
#else  /* OS_CORE_ID_MASTER  */
#define OS_CORE_ID_SLAVE OS_CORE_ID_0
#endif /* OS_CORE_ID_MASTER */


#endif /* PERF_PROFOOK_H */
