/*
 *  TOPPERS/A-OSBENCH
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Operating System Benchmark
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: perf_terapp_t.c 783 2014-05-29 00:56:33Z honda $
 */

#include "perf_terapp.h"
#include "perf_terapp_t.h"


/* overhead value */
volatile uint32 overhead_time = 0;

/*
 *  ¹ԻʬۤϿΰ: 65535ޤǷ¬ǽȤ
 */
uint16 histarea[2][MAX_TIME + 1];
uint16 histarea100us[MAX_TIME_100US + 1];

/*
 * ᥤؿ
 */
sint32
main(void)
{
#ifndef USE_MC_KERNEL
	test_init_test_lib();
	perf_timer_initialize();
	StartOS(MainApp);
#else   /* USE_MC_KERNEL */
	StatusType	ercd;
	CoreIdType	i;

	if (GetCoreID() == OS_CORE_ID_MASTER) {
		test_init_test_lib();
		test_init_test_lib_eachcore();
		for (i = 0; i < TotalNumberOfCores; i++) {
			if (i != OS_CORE_ID_MASTER) {
				StartCore(i, &ercd);
			}
		}
		StartOS(MainApp);
	}
	else {
		test_init_test_lib_eachcore();
		StartOS(DONOTCARE);
	}
#endif /* USE_MC_KERNEL */

	while (1) {}
}   /* main */


/*
 *  histareaޤȤƽؿ
 */
void init_hist_group(uint8 loop)
{
	uint8 i;
	for (i = 0; i < loop; i++) {
		init_hist(i + TMIN_HISTID, MAX_TIME, histarea[i]);
	}
}


/* ¬˼»ܤؿ */
void init_perf_func(uint8 hist_loop)
{
	init_hist_group(hist_loop);

	perf_timer_initialize();

#ifdef USE_MC_KERNEL
	test_init_sync_cnt();
#endif /* USE_MC_KERNEL */
}


/*
 * *************************************
 * *********** ᥤ󥿥 ************
 * *************************************
 */
TASK(MainTask)
{
	uint32 i;

	perf_timer_initialize();

#if defined(USE_MC_KERNEL) && defined(SLAVE_IDLE_TASK)
	ActivateTask(S_IdleTask);
#endif /* USE_MC_KERNEL && SLAVE_IDLE_TASK */

/* *** measure overhead *** */
	test_outputlog_0("== measure overhead ==");
	init_hist(1, MAX_TIME_100US, histarea100us);
	for (i = 0; i < LOOP_COUNT; i++) {
		begin_measure(1);
		end_measure(1);
	}
	print_hist(1);


/* *** OverHead Time *** */
	overhead_time = calc_hist_value(1, RET_MIN_VALUE);
	test_outputlog_1("== overhead_time:%d[100nsec] ==",overhead_time);


/* *** TerApp_A *** */
#ifdef USE_MC_KERNEL
	test_outputlog_0("== TerApp_A[MC] ==");
#else  /* USE_MC_KERNEL */
	test_outputlog_0("== TerApp_A ==");
#endif /* USE_MC_KERNEL */

	/* number_of_objects:1 */
	init_perf_func(1);
	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP1_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP2_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);
	
	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP3_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP4_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP5_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP6_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP7_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP8_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP9_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP10_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	test_outputlog_0("== TerApp-1(number_of_objects:1) ==");
	print_hist(1);

	/* number_of_objects:4 */
	init_perf_func(1);
	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP11_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP12_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);
	
	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP13_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP14_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP15_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP16_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP17_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP18_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP19_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP20_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	test_outputlog_0("== TerApp-1(number_of_objects:4) ==");
	print_hist(1);

	/* number_of_objects:8 */
	init_perf_func(1);
	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP21_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP22_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);
	
	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP23_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP24_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP25_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP26_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP27_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP28_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP29_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	SEQUENCE_CHECK_START();
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 1);
	ActivateTask(T_OSAP30_TerApp_A_Task1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 5);

	test_outputlog_0("== TerApp-1(number_of_objects:8) ==");
	print_hist(1);
	test_outputlog_0("All evaluation items were measured.");

#ifndef USE_MC_KERNEL
	ShutdownOS(E_OK);
#else  /* USE_MC_KERNEL */
	ShutdownAllCores(E_OK);
#endif /* USE_MC_KERNEL */
}


/*
 * *************************************
 * ***** ƽñ̤ ******
 * *************************************
 */
/* number_of_objects:1 */
/* T_OSAP1 */
TASK(T_OSAP1_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP1_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP2 */
TASK(T_OSAP2_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP2_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP3 */
TASK(T_OSAP3_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP3_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP4 */
TASK(T_OSAP4_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP4_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP5 */
TASK(T_OSAP5_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP5_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP6 */
TASK(T_OSAP6_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP6_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP7 */
TASK(T_OSAP7_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP7_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP8 */
TASK(T_OSAP8_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP8_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP9 */
TASK(T_OSAP9_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP9_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP10 */
TASK(T_OSAP10_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP10_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* number_of_objects:4 */
/* T_OSAP11 */
TASK(T_OSAP11_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP11_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP12 */
TASK(T_OSAP12_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP12_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP13 */
TASK(T_OSAP13_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP13_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP14 */
TASK(T_OSAP14_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP14_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP15 */
TASK(T_OSAP15_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP15_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP16 */
TASK(T_OSAP16_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP16_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP17 */
TASK(T_OSAP17_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP17_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP18 */
TASK(T_OSAP18_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP18_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP19 */
TASK(T_OSAP19_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP19_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP20 */
TASK(T_OSAP20_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP20_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* number_of_objects:8 */
/* T_OSAP21 */
TASK(T_OSAP21_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP21_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP22 */
TASK(T_OSAP22_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP22_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP23 */
TASK(T_OSAP23_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP23_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP24 */
TASK(T_OSAP24_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP24_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP25 */
TASK(T_OSAP25_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP25_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP26 */
TASK(T_OSAP26_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP26_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP27 */
TASK(T_OSAP27_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP27_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP28 */
TASK(T_OSAP28_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP28_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP29 */
TASK(T_OSAP29_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP29_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}

/* T_OSAP30 */
TASK(T_OSAP30_TerApp_A_Task1)
{
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 2);
	ActivateTask(NT_OSAP30_TerApp_A_Task2);
	end_measure(1);
	SEQUENCE_CHECK(OS_CORE_ID_MASTER, 4);

	TerminateTask();

}


/* MC KERNEL */
#if defined(USE_MC_KERNEL) && defined(SLAVE_IDLE_TASK)
/* IdleTask(SlaveCore) */
TASK(S_IdleTask)
{
	idle_task_process(OS_CORE_ID_SLAVE);
	TerminateTask();
}
#endif /* USE_MC_KERNEL && SLAVE_IDLE_TASK */


/*
 *  顼եå롼
 */
void ErrorHook(StatusType Error)
{
	test_outputlog_0("Error was occured!!");
}
